UNIT CAP_Bedienen;

INTERFACE
USES BENUTZER;                  { der Datentyp Messbereiche wird importiert }

  PROCEDURE InterfaceStarten;

  PROCEDURE ProgrammBeenden;

  PROCEDURE SensSetzen   (bereich: MessBereiche);
                 { Setzen des Messbereiches mittels einer Ganzzahlenvorgabe }

  FUNCTION MessWertHolen (VAR overflow: BOOLEAN): REAL;
            { Holen eines Messwertes vom Interface und Rckgabe ans Programm
              mit Meldung der Mebereichsberschreitung }


IMPLEMENTATION {------------------------------------------------------------}
  USES CAP_CS2;

  VAR  MaxSpannung: REAL;  { Variable, die die maximal messbare Spannung
                             des aktuellen Bereiches angibt }

    PROCEDURE InterfaceStarten;
    BEGIN
                        { Initialisierung wird von CAP_CS2 UNIT vorgenommen }
    END;

    PROCEDURE ProgrammBeenden;
    BEGIN
                                    { Reset ist bei CAP_CS2 nicht notwendig }
    END;

    PROCEDURE SensSetzen (bereich: MessBereiche);
                { Setzen der Empfindlichkeit des AD-Eingangs B am Interface }
    VAR  Tmp: AD_Sens;
    BEGIN
      CASE bereich OF
        1: BEGIN  Tmp := AD_03V;  MaxSpannung := 0.3;  END;
        2: BEGIN  Tmp := AD_1V;   MaxSpannung := 1;    END;
        3: BEGIN  Tmp := AD_3V;   MaxSpannung := 3;    END;
        4: BEGIN  Tmp := AD_10V;  MaxSpannung := 10;   END;
        ELSE
                       { Anzeige, da falscher Messbereich eingestellt wurde }
      END;
      AD_Init (AD_B, Tmp);
    END;

    FUNCTION MessWertHolen(VAR overflow: BOOLEAN): REAL;
            { Holen eines Messwertes aus dem Interface, sowie Umrechnug REAL }
    VAR
      Wert:     SHORTINT;
      Ergebnis: REAL;
    BEGIN
      Wert := AD (AD_B);
      IF ABS(Wert) > 125 THEN
         BEGIN
           overflow := TRUE;
           Ergebnis := 0;
         END
       ELSE
         BEGIN
           Ergebnis := MaxSpannung * Wert / 125;
           overflow := FALSE;
         END;
      MessWertHolen := Ergebnis;
    END;

BEGIN  {------------------------- Initialisieren der UNIT ------------------ }
  SensSetzen(4);                            {  Messbereich und 'MaxSpannung' }
END.
